<?php

/**
 * Skripta sadrži funkcije za pozive prema REST API-u. Rezultati se spremaju u cache, ttl 4 sata.
 *
 * @package    local_dabar
 * @copyright  2015 Srce, Centar za e-učenje (http://www.srce.unizg.hr/ceu)
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
global $CFG;
require_once($CFG->dirroot . '/lib/filelib.php');

class restClient extends curl{
	protected $username, $password, $acceptType = 'application/json', $contentType = 'multipart/form-data';

	public function __construct($settings = array()){
		parent::__construct($settings);
	}

	public function setAuth($username, $password){
		$this->username = $username;
		$this->password = $password;
	}

	public function setAcceptType($acceptType = 'application/json'){
		$this->acceptType = $acceptType;
	}
	
	public function setContentType($contentType = 'multipart/form-data'){
		$this->contentType = $contentType;
	}

	public function post($url, $params = array(), $options = array()) {
		$fields = [
			$params['name'] => new \CurlFile($params['file'])
		];

		$options['CURLOPT_CUSTOMREQUEST'] = 'POST';
		$options['CURLOPT_POST'] = 1;
		$options['CURLOPT_POSTFIELDS'] = $fields;
		$this->setHeader(array('Content-Type: '.$this->contentType));

		$ret = $this->request($url, $options);
		return $ret;
	}

	public function request($url, $options = array()){
		$headers = array('Accept: '.$this->acceptType);
		$this->setHeader($headers);
		$options['CURLOPT_HTTPAUTH']   = CURLAUTH_BASIC;
		$options['CURLOPT_USERPWD']    = $this->username.":".$this->password;
		$options['CURLOPT_SSLVERSION'] = 1;

		$ret = parent::request($url, $options);

		$this->resetHeader();
		$this->resetopt();
		$this->setAcceptType();

		if (empty($this->error)) {
			return $ret;
		}
		else{
			return false;
		}
	}
}
?>